---
kind: Cluster
apiVersion: kind.x-k8s.io/v1alpha4
containerdConfigPatches:
- |-
  [plugins."io.containerd.grpc.v1.cri".registry]
    config_path = "/etc/containerd/certs.d"
nodes:
{% for node in nodes %}
{% if node.active == "true" %}

  - role: {{ node.role }}
    image: {{ node.image }}
    kubeadmConfigPatches:
      - |
        kind: {{ "InitConfiguration" if node.role == "control-plane" else "JoinConfiguration" }}
        nodeRegistration:
          kubeletExtraArgs:
            node-labels: "ingress-ready=true,kubernetes.wmcloud.org/nfs-mounted=true"

{% if node.name == "toolforge-control-plane" %}
    extraPortMappings:
      - containerPort: {{ kind.api.port }}
        hostPort: {{ kind.api.port }}
        protocol: TCP
{% for port in kind.extra_forward_ports %}
      - containerPort: {{ port }}
        hostPort: {{ port }}
        protocol: TCP
{% endfor %}
{% endif %}

    extraMounts:
{% for dir in toolforge.directories %}
      - hostPath: {{ dir }}
        containerPath: {{ dir }}
{% endfor %}
{% for file in toolforge.files %}
      - hostPath: {{ file.path }}
        containerPath: {{ file.path }}
        propagation: Bidirectional
{% endfor %}
{% if use_cache == "true" %}
      - hostPath: {{ cache_disk_mount }}/{{ node.name }}
        containerPath: /var/lib/containerd
        propagation: Bidirectional
{% endif %}
      - hostPath: {{ kind.files.containerd_hosts_config.path }}
        containerPath: {{ kind.files.containerd_hosts_config.path }}
        propagation: Bidirectional
      - hostPath: /etc/nsswitch.conf
        containerPath: /etc/nsswitch.conf
        propagation: Bidirectional

{% endif %}
{% endfor %}
